package com.swmrs.model;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import java.sql.Timestamp;

@Entity
public class Bill {
    @Id
    @GeneratedValue(strategy= GenerationType.IDENTITY)
    @Column(nullable = false, unique = true, updatable = false)
    private int id;
    @Column(length = 50, nullable = false)
    private String userId;
    @Column(nullable = false)
    private Timestamp dateFrom;
    @Column(nullable = false)
    private Timestamp dateTo;
    @Column(nullable = false)
    private double previousDue;
    @Column(nullable = false)
    private int lastReading;
    @Column(nullable = false)
    private int currentReading;
    @Column(nullable = false)
    private int usage;
    @Column(nullable = false)
    private double usageCharge;
    @Column(nullable = false)
    private double serviceCharge;
    @Column(nullable = false)
    private double totalBeforeTax;
    @Column(nullable = false)
    private double vat;
    @Column(nullable = false)
    private double totalBillAmount;
    @Column(nullable = false)
    private double totalPayable;

    public int getId() {
        return id;
    }

    public void setId(int id) {
        this.id = id;
    }

    public String getUserId() {
        return userId;
    }

    public void setUserId(String userId) {
        this.userId = userId;
    }

    public Timestamp getDateFrom() {
        return dateFrom;
    }

    public void setDateFrom(Timestamp dateFrom) {
        this.dateFrom = dateFrom;
    }

    public Timestamp getDateTo() {
        return dateTo;
    }

    public void setDateTo(Timestamp dateTo) {
        this.dateTo = dateTo;
    }

    public double getPreviousDue() {
        return previousDue;
    }

    public void setPreviousDue(double previousDue) {
        this.previousDue = previousDue;
    }

    public int getLastReading() {
        return lastReading;
    }

    public void setLastReading(int lastReading) {
        this.lastReading = lastReading;
    }

    public int getCurrentReading() {
        return currentReading;
    }

    public void setCurrentReading(int currentReading) {
        this.currentReading = currentReading;
    }

    public int getUsage() {
        return usage;
    }

    public void setUsage(int usage) {
        this.usage = usage;
    }

    public double getUsageCharge() {
        return usageCharge;
    }

    public void setUsageCharge(double usageCharge) {
        this.usageCharge = usageCharge;
    }

    public double getServiceCharge() {
        return serviceCharge;
    }

    public void setServiceCharge(double serviceCharge) {
        this.serviceCharge = serviceCharge;
    }

    public double getTotalBeforeTax() {
        return totalBeforeTax;
    }

    public void setTotalBeforeTax(double totalBeforeTax) {
        this.totalBeforeTax = totalBeforeTax;
    }

    public double getVat() {
        return vat;
    }

    public void setVat(double vat) {
        this.vat = vat;
    }

    public double getTotalBillAmount() {
        return totalBillAmount;
    }

    public void setTotalBillAmount(double totalBillAmount) {
        this.totalBillAmount = totalBillAmount;
    }

    public double getTotalPayable() {
        return totalPayable;
    }

    public void setTotalPayable(double totalPayable) {
        this.totalPayable = totalPayable;
    }
}
