package com.swmrs.model;

import com.swmrs.enums.Tariff;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.persistence.Id;
import java.sql.Timestamp;

@Entity
public class Consumer {
    @Id
    @Column(length = 50, nullable = false, unique = true)
    private String userId;
    @Column(length = 250, nullable = false)
    private String firstName;
    @Column(length = 250, nullable = false)
    private String lastName;
    @Column(length = 350, nullable = false, unique = true)
    private String email;
    @Column(length = 2000, nullable = false)
    private String address;
    @Column(length = 15, nullable = false)
    private String contactNo;
    @Column(length = 20, nullable = false)
    private String postalCode;
    @Column(length = 50, nullable = false)
    private String district;
    @Enumerated(EnumType.STRING)
    @Column(length = 50, nullable = false)
    private Tariff connectionType;
    private double dueAmount;
    private Timestamp lastBilledDate;
    private int lastBilledReading;
    private double lastPayment;
    private Timestamp lastPaymentDate;

    public Consumer() {
    }

    public Consumer(String userId, String firstName, String lastName, String email, String address, String contactNo,
                    String postalCode, Tariff connectionType, String district) {
        this.userId = userId;
        this.firstName = firstName;
        this.lastName = lastName;
        this.email = email;
        this.address = address;
        this.contactNo = contactNo;
        this.postalCode = postalCode;
        this.connectionType = connectionType;
        this.district = district;
    }

    public String getUserId() {
        return userId;
    }

    public void setUserId(String userId) {
        this.userId = userId;
    }

    public String getFirstName() {
        return firstName;
    }

    public void setFirstName(String firstName) {
        this.firstName = firstName;
    }

    public String getLastName() {
        return lastName;
    }

    public void setLastName(String lastName) {
        this.lastName = lastName;
    }

    public String getEmail() {
        return email;
    }

    public void setEmail(String email) {
        this.email = email;
    }

    public String getAddress() {
        return address;
    }

    public void setAddress(String address) {
        this.address = address;
    }

    public String getContactNo() {
        return contactNo;
    }

    public void setContactNo(String contactNo) {
        this.contactNo = contactNo;
    }

    public String getPostalCode() {
        return postalCode;
    }

    public void setPostalCode(String postalCode) {
        this.postalCode = postalCode;
    }

    public Tariff getConnectionType() {
        return connectionType;
    }

    public void setConnectionType(Tariff connectionType) {
        this.connectionType = connectionType;
    }

    public double getDueAmount() {
        return dueAmount;
    }

    public void setDueAmount(double dueAmount) {
        this.dueAmount = dueAmount;
    }

    public double getLastPayment() {
        return lastPayment;
    }

    public void setLastPayment(double lastPayment) {
        this.lastPayment = lastPayment;
    }

    public Timestamp getLastBilledDate() {
        return lastBilledDate;
    }

    public void setLastBilledDate(Timestamp lastBilledDate) {
        this.lastBilledDate = lastBilledDate;
    }

    public int getLastBilledReading() {
        return lastBilledReading;
    }

    public void setLastBilledReading(int lastBilledReading) {
        this.lastBilledReading = lastBilledReading;
    }

    public Timestamp getLastPaymentDate() {
        return lastPaymentDate;
    }

    public void setLastPaymentDate(Timestamp lastPaymentDate) {
        this.lastPaymentDate = lastPaymentDate;
    }

    public String getDistrict() {
        return district;
    }

    public void setDistrict(String district) {
        this.district = district;
    }
}
