package com.swmrs.objects;

import com.fasterxml.jackson.databind.JsonNode;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.swmrs.model.Notification;
import com.swmrs.repo.NotificationRepo;
import org.apache.http.Header;
import org.apache.http.HttpEntity;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.methods.CloseableHttpResponse;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.impl.client.HttpClients;
import org.apache.http.util.EntityUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import java.io.IOException;
import java.sql.Timestamp;
import java.util.Date;

@Component
public class Scheduler {
    @Autowired
    private NotificationRepo notificationRepo;
    @Scheduled(cron = "0 0 0 1 * ?")  //At 00:00:00am, on the 1st day, every month
    public void cronJobSch() {
        String msg = "";
        HttpGet request = new HttpGet("http://localhost:8083/generateBill");
        request.addHeader("content-type", "application/json");
        request.addHeader("Authorization", "Bearer eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9" +
                ".eyJleHAiOjE1OTI1NDg4MTksInVzZXJfbmFtZSI6IkpvaG4iLCJhdXRob3JpdGllcyI6WyJBRE1JTiJdLCJqdGkiOiI2MTNjNzdjYS1iMWRkLTRhMmYtYTkyYy1iNjVkOWRhNGRmMTkiLCJjbGllbnRfaWQiOiJ0ZXN0Q2xpZW50SWQiLCJzY29wZSI6WyJyZWFkIiwid3JpdGUiXX0.DQItrI-fJc-rkyRs07n4ZiVqzjiPQYzEv6adSCovyCY");

        try (CloseableHttpClient httpClient = HttpClients.createDefault(); CloseableHttpResponse response =
                httpClient.execute(request)) {

            HttpEntity entity = response.getEntity();

            if (entity != null) {
                // return it as a String
                String result = EntityUtils.toString(entity);
                //convert response entity as json
                ObjectMapper mapper = new ObjectMapper();
                JsonNode message = mapper.readTree(result);
                msg = message.get("message").asText();
            }
            else {
                msg = "Response Entity is null";
            }

        } catch (ClientProtocolException e) {
            msg = e.getMessage().toString();
        } catch (IOException e) {
            msg = e.getMessage().toString();
        }
        Notification notification = new Notification(msg,new Timestamp(new Date().getTime()));
        notificationRepo.save(notification);
    }
}
