package com.swmrs.repo;

import com.swmrs.model.Bill;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;

public interface BillRepo extends CrudRepository<Bill, Integer> {
    Bill findById(int billId);
    Iterable<Bill> findAllByUserId( String userId);

    @Query(value = "SELECT SUM(`usage`) from `bill`", nativeQuery = true)
    Long findTotalUsage();

    @Query(value = "SELECT SUM(`usage`) from `bill` where user_id=?1", nativeQuery = true)
    Long findTotalUsageByUserId(String userId);

    @Query(value = "SELECT COUNT(`id`) FROM `bill` WHERE user_id =?1", nativeQuery = true)
    Long findCountByUserId(String userId);

    @Query(value = "SELECT SUM(`total_bill_amount`) from `bill`", nativeQuery = true)
    Double findTotalBilledAmount();

    @Query(value = "SELECT SUM(`total_bill_amount`) from `bill` where user_id=?1", nativeQuery = true)
    Double findTotalBilledAmountByUserId(String userId);

}
