package com.swmrs.repo;

import com.swmrs.model.Consumer;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;

import java.util.List;
import java.util.Map;

public interface ConsumerRepo extends CrudRepository<Consumer, String> {
    Consumer findByUserId(String userId);
    Iterable<Consumer> findByDistrict(String district);

    @Query(value = "SELECT `postal_code`,  COUNT(*) AS `count` FROM  `consumer`GROUP BY  `postal_code`",nativeQuery = true)
    List<Map<String, Long>> countPostalCodes();

    @Query (value = "SELECT consumer.postal_code, SUM(bill.usage ) as `total_usage` FROM `consumer` JOIN `bill` WHERE" +
            " consumer.user_id = bill.user_id GROUP BY consumer.postal_code", nativeQuery = true)
    List<Map<String, Long>> totalUsagePostalCode();

    @Query(value = "SELECT `connection_type`,  COUNT(*) AS `count` FROM  `consumer`GROUP BY  `connection_type`",nativeQuery = true)
    List<Map<String, Long>> countConnectionType();

    @Query(value = "SELECT * FROM `consumer` WHERE `due_amount`<0",nativeQuery = true)
    Iterable<Consumer> hasExcessBalance();
    @Query(value = "SELECT * FROM `consumer` WHERE `due_amount`>0",nativeQuery = true)
    Iterable<Consumer> hasDues();


}
