package com.swmrs.repo;

import com.swmrs.model.Payment;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;

public interface PaymentRepo extends CrudRepository<Payment, Integer> {
    Payment findById(int paymentId);

    Iterable<Payment> findAllByUserId( String userId);

    @Query(value = "SELECT SUM(`payment_amount`) from `payment`", nativeQuery = true)
    Double findTotalPayment();

    @Query(value = "SELECT SUM(`payment_amount`) from `payment` where user_id=?1", nativeQuery = true)
    Double findTotalPaymentByUserId(String userId);

    @Query(value = "SELECT COUNT(`id`) from `payment` where user_id=?1", nativeQuery = true)
    Long findCountByUserId(String userId);
}
