package com.swmrs.repo;

import com.swmrs.model.Usage;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;

import java.sql.Timestamp;

public interface UsageRepo extends CrudRepository<Usage, Integer> {
    Usage findById(int usageId);
    Iterable<Usage> findAllByUserId( String userId);
    @Query(value ="SELECT * FROM `usage` WHERE time >= ?1 && time<= ?2", nativeQuery = true)
    Iterable<Usage> findUsageByInterval(Timestamp StartDate, Timestamp EndDate);

    @Query(value ="SELECT * FROM `usage` WHERE time >= ?1 && time<= ?2 && user_id= ?3", nativeQuery = true)
    Iterable<Usage> findUserUsageByInterval(Timestamp StartDate, Timestamp EndDate, String userId);

    @Query(value = "SELECT * FROM `usage` where user_id=?1 ORDER BY id  DESC LIMIT 1", nativeQuery = true)
    Usage findLastUsageByUserId(String userId);
}
